/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2000-2007 Sun Microsystems, Inc. All rights reserved. 
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License ("CDDL") (collectively, the "License").  You may
 * not use this file except in compliance with the License.  You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or mq/legal/LICENSE.txt.  See the License for the specific language
 * governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at mq/legal/LICENSE.txt.  Sun designates
 * this particular file as subject to the "Classpath" exception as provided by
 * Sun in the GPL Version 2 section of the License file that accompanied this
 * code.  If applicable, add the following below the License Header, with the
 * fields enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or  to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright holder. 
 */

/*
 * @(#)L0.java	1.13 06/28/07
 */ 

package com.sun.messaging.jmq.jmsserver.license;

import java.io.*;
import java.util.*;
import java.security.*;
import com.sun.messaging.jmq.jmsserver.util.BrokerException;

/**
 * This is a generated license class file.
 */
public class L0 extends LicenseBase {
    private static byte[] data = {
        -52, -96, 124, 123, -57, -104, -126, 104, -65, -85, 
        -94, -71, -89, -95, -103, -98, -103, -109, -106, -105, 
        -89, 117, 127, 109, -97, -117, -117, -119, -127, -85, 
        74, 68, 62, 127, 70, 59, 70, 67, 55, 60, 
        64, 49, 44, 54, 54, 41, 47, 44, 28, 25, 
        78, 21, 21, 16, 30, 119, 22, 16, 10, 75, 
        18, 7, 18, 15, 3, 8, 12, 1, 6, 40, 
        -17, -17, -22, -8, 81, -11, -10, -31, -18, -14, 
        -36, -39, -39, -32, -39, -34, 6, -13, -16, -17, 
        -10, 47, -50, -56, -62, 3, -62, -52, -95, -54, 
        -59, -89, -89, -74, -70, -95, -68, -74, -98, -99, 
        -108, -97, -46, -37, -38, -43, -48, -47, -53, -50, 
        -55, -55, -60, -17, -107, -103, -99, -61, -103, -115, 
        114, -117, -113, 120, -107, -111, 112, 104, -117, -113, 
        103, 102, 100, 77, -110, -101, -102, -107, -112, -111, 
        -117, -114, -119, -119, -124, -81, 66, 62, 69, -125, 
        55, 58, 60, 51, 66, 71, 51, 58, 79, 36, 
        68, 57, 105, 32, 73, 64, -123, 61, 30, 24, 
        90, 57, 21, 53, 54, 17, 22, 51, 9, 6, 
        20, 16, 12, 2, 17, -11, -11, -16, -2, 87, 
        -10, -16, -22, 42, -14, -25, -14, -17, -29, -24, 
        -20, -42, -44, -39, 17, -51, -51, -56, -42, 54, 
        -50, -56, -62, -10, -54, -65, -54, -57, -69, -64, 
        -60, -69, -66, -76, -81, -86, -95, -80, -95, -44, 
        -101, -101, -106, -92, -4, -100, -106, -112, -47, -104, 
        -115, -104, -107, -119, -114, -110, -118, -116, -120, 119, 
        124, -90, 109, 109, 104, 118, -36, 110, 104, 98, 
        -93, 106, 95, 106, 103, 91, 96, 100, 89, 75, 
        73, 75, 124, 67, 67, 62, 76, -91, 68, 62, 
        56, 121, 64, 53, 64, 61, 49, 54, 58, 36, 
        45, 50, 31, 42, 41, 44, 22, 18, 35, 70, 
        13, 13, 8, 22, 111, 14, 8, 2, 67, 10, 
        -1, 10, 7, -5, 0, 4, -12, -16, -17, -14, 
        -27, -24, -29, -22, -29, -24, 16, -41, -41, -46, 
        -32, 57, -40, -46, -52, 13, -44, -55, -44, -47, 
        -59, -54, -50, -84, -60, -60, -87, -88, -94, -70, 
        -70, -98, -36, -101, -107, -93, -97, 5, -102, -112, 
        -97, -39, -106, -100, -107, -109, -102, -120, -112, -95, 
        -106, -124, 126, -109, -110, 122, 121, 119, 120, -90, 
        108, 108, 103, -109, -49, 109, 103, 105, -93, 66, 
        74, 109, 101, 97, 96, 93, 64, 91, 87, 107, 
        -122, -121, -123, -125, -89, 53, 51, 67, 123, 49, 
        64, 58, 46, 62, 43, 43, 41, 62, 32, 32, 
        29, 55, 27, 107, 21, 21, 16, 55, 119, 22, 
        16, 10, 92, 10, 20, -5, 18, 14, 10, -9, 
        0, -15, 0, 4, -2, -16, -17, -24, 19, 36, 
        35, 17, 14, 9, 4, 5, 2, 10, 3, 49, 
        -40, -46, -52, 4, -44, -55, -44, -47, -59, -54, 
        -50, -54, -76, -61, -68, -81, -62, -68, -70, -72, 
        -36, -93, -93, -98, -84, 4, -92, -98, -104, -39, 
        -96, -107, -96, -99, -111, -106, -102, -108, -119, -118, 
        -116, -127, 119, 121, 126, 119, 124, -92, 107, 107, 
        102, 116, -38, 113, 110, 94, 108, 91, 98, 89, 
        83, 92, 84, 83, -126, 106, 70, 75, -105, 107, 
        82, 59, 78, -123, 55, 60, 126, -123, 80, 40, 
        44, 41, 54, 44, 119, 72, 46, 30, 28, 44, 
        36, 36, 103, 52, 14, 28, 10, 24, 91, 69, 
        73, 68, 83, 44, 1, -7, 6, -9, -9, -13, 
        -6, -18, -6, 61, 22, -11, -18, -31, -22, -30, 
        -31, 67, -30, -36, -42, 23, -42, -32, -57, -34, 
        -39, -40, -44, -54, -79, -63, -48, -54, -97, -98, 
        -87, -24, -15, -16, -21, -26, -25, -31, -28, -33, 
        -33, -38, 5, -109, -106, -95, -39, -100, -110, -115, 
        -111, -98, -93, -107, -113, 126, -107, 126, 123, -103, 
        123, 122, -86, -79, -75, -80, -43, 115, 117, 103, 
        -87, 111, 100, 111, 108, 96, 109, 105, 98, 61, 
        70, 115, 65, 66, 57, 84, -83, 57, 61, 65, 
        -127, 53, 62, 55, 50, 60, 53, 47, 61, 67, 
        55, 44, 63, 52, 26, 38, 51, 30, 30, 25, 
        21, 53, 16, 14, 22, 14, 13, 59, 3, 3, 
        -2, 12, 101, 4, -2, -8, 56, -1, -6, -11, 
        -6, -2, -27, -12, -27, -30, -22, -30, -31, 4, 
        4, 54, };

    public L0() throws BrokerException {
        super();

        try {
            byte[] plain = FileLicense.scramble(data);
            ByteArrayInputStream bais =
                new ByteArrayInputStream(plain);
            Properties tmp = new Properties();
            tmp.load(bais);
            superimpose(tmp);
        }
        catch (Exception e) {
            throw new BrokerException("Bad license.", e);
        }
    }

    public boolean isLicenseFileRequired() {
        return false;
    }

    public static void main(String args[]) throws Exception {
        L0 l = new L0();
        System.out.println(l.getProperties());
    }
}

/*
 * EOF
 */
