/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2000-2007 Sun Microsystems, Inc. All rights reserved. 
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License ("CDDL") (collectively, the "License").  You may
 * not use this file except in compliance with the License.  You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or mq/legal/LICENSE.txt.  See the License for the specific language
 * governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at mq/legal/LICENSE.txt.  Sun designates
 * this particular file as subject to the "Classpath" exception as provided by
 * Sun in the GPL Version 2 section of the License file that accompanied this
 * code.  If applicable, add the following below the License Header, with the
 * fields enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or  to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright holder. 
 */

/*
 * @(#)BrokerClusterInfo.java	1.13 07/02/07
 */ 

package com.sun.messaging.jms.management.server;

/**
 * This class contains constants/names for fields in the CompositeData
 * that is returned by the operations of the Cluster Monitor and Cluster
 * Config MBeans.
 */
public class BrokerClusterInfo implements java.io.Serializable  {
    /**
     * Address of broker in the form of host:port
     */
    public static final String ADDRESS			= "Address";

    /**
     * The ID of the broker.
     */
    public static final String ID     			= "ID";

    /**
     * State of broker
     */
    public static final String STATE  			= "State";

    /**
     * State label of broker. This is useful when viewe in a JMX browser
     * like jconsole.
     */
    public static final String STATE_LABEL		= "StateLabel";

    /**
     * Number of messages stored in this broker's message store.
     */
    public static final String NUM_MSGS			= "NumMsgs";

    /**
     * ID of the broker that has taken over this broker's store.
     */
    public static final String TAKEOVER_BROKER_ID	= "TakeoverBrokerID";

    /**
     * Status Timestamp.
     */
    public static final String STATUS_TIMESTAMP		= "StatusTimestamp";

    /*
     * Class cannot be instantiated
     */
    private BrokerClusterInfo() {
    }
}
